%Very good one there makes 1-5 gausians.


chromatFile = 'Input1.txt';
[allChromats] = dlmread(chromatFile);
[lengthChromats,numChromats] = size(allChromats);



for chromatograph = 1:4
Gaus1_test = 0;
y = allChromats(:,chromatograph);
x = (1:numel(y))';
High =  length(find(y > 0.5));
N = length(x);
ok_ = isfinite(x) & isfinite(y);
mH = max(y); %finding max height in chromatogram;
CVerr_Gauss_1 =999;
CVerr_Gauss_2 =999;
CVerr_Gauss_3 =999;
CVerr_Gauss_4 =999;
CVerr_Gauss_5 =999;
CVerr_Gauss_6 =999;
CVerr_Gauss_7 =999;
CVerr_Gauss_8 =999;

  if ~all( ok_ )
  warning( 'GenerateMFile:IgnoringNansAndInfs',...
    'Ignoring NaNs and Infs in data.' );
  end
    
  
  
%% One gaussian
if High <6
   [curveFit1,goodness1,probs1] = fit(x(ok_),y(ok_),(fittype('gauss1')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3],'Upper',[mH 50 8])));
  CVerr_Gauss_1 = 777;

%% Two gaussian
elseif High <9
    [curveFit1,goodness1,probs1] = fit(x(ok_),y(ok_),(fittype('gauss1')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3],'Upper',[mH 50 8]))); 
    [curveFit2,goodness2,probs2] = fit(x(ok_),y(ok_),(fittype('gauss2')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3 1 0.1 0.3],'Upper',[mH 50 8 mH 50 8])));
    
    
    %Gaus1
    sse = 0;
    parfor i = 1:500
      [train,test] = crossvalind('LeaveMOut',N,1);
      [curveFit,goodness,probs] = fit(x(train),y(train),(fittype('gauss1')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[ 1 0.1 0.3],'Upper',[mH 50 8])));
      if probs.('iterations')>390;
        sse = sse + 5;
      else yhat = feval(curveFit,x(test));
        sse = sse + sum((yhat - y(test)).^2);
      end
    end
    CVerr_Gauss_1 = sse / 500;
  
 

    %Gaus2
    sse = 0;
    parfor i = 1:500
      [train,test] = crossvalind('LeaveMOut',N,1);
      [curveFit,goodness,probs] = fit(x(train),y(train),(fittype('gauss2')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3 1 0.1 0.3],'Upper',[mH 50 8 mH 50 8])));
      if probs.('iterations')>390;
        sse = sse + 5;
      else yhat = feval(curveFit,x(test));
        sse = sse + sum((yhat - y(test)).^2);
      end
    end
    CVerr_Gauss_2 = sse / 500;
  
   
%% Three Gaussian 
    elseif High <12
    
    [curveFit1,goodness1,probs1] = fit(x(ok_),y(ok_),(fittype('gauss1')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3],'Upper',[mH 50 8]))); 
    [curveFit2,goodness2,probs2] = fit(x(ok_),y(ok_),(fittype('gauss2')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3 1 0.1 0.3],'Upper',[mH 50 8 mH 50 8])));
    [curveFit3,goodness3,probs3] = fit(x(ok_),y(ok_),(fittype('gauss3')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3 1 0.1 0.3 1 0.1 0.3],'Upper',[mH 50 8 mH 50 8 mH 50 8])));
    
    
    %Gaus1
    sse = 0;
    parfor i = 1:500
      [train,test] = crossvalind('LeaveMOut',N,1);
      [curveFit,goodness,probs] = fit(x(train),y(train),(fittype('gauss1')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[ 1 0.1 0.3],'Upper',[mH 50 8])));
      if probs.('iterations')>390;
        sse = sse + 5;
      else yhat = feval(curveFit,x(test));
        sse = sse + sum((yhat - y(test)).^2);
      end
    end
    CVerr_Gauss_1 = sse / 500;
   
    %Gaus2
    sse = 0;
    parfor i = 1:500
      [train,test] = crossvalind('LeaveMOut',N,1);
      [curveFit,goodness,probs] = fit(x(train),y(train),(fittype('gauss2')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3 1 0.1 0.3],'Upper',[mH 50 8 mH 50 8])));
      if probs.('iterations')>390;
        sse = sse + 5;
      else yhat = feval(curveFit,x(test));
        sse = sse + sum((yhat - y(test)).^2);
      end
    end
    CVerr_Gauss_2 = sse / 500;
  
    %Gaus3    
    sse = 0;
    parfor i = 1:500
      [train,test] = crossvalind('LeaveMOut',N,1);
      [curveFit,goodness,probs] = fit(x(train),y(train),(fittype('gauss3')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3 1 0.1 0.3 1 0.1 0.3],'Upper',[mH 50 8 mH 50 8 mH 50 8])));
      if probs.('iterations')>390;
        sse = sse + 5;
      else yhat = feval(curveFit,x(test));
        sse = sse + sum((yhat - y(test)).^2);
      end
  end
   CVerr_Gauss_3 = sse / 500;
   
%% Four Gaussian 
    elseif High <15 
    
    [curveFit1,goodness1,probs1] = fit(x(ok_),y(ok_),(fittype('gauss1')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3],'Upper',[mH 50 8]))); 
    [curveFit2,goodness2,probs2] = fit(x(ok_),y(ok_),(fittype('gauss2')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3 1 0.1 0.3],'Upper',[mH 50 8 mH 50 8])));
    [curveFit3,goodness3,probs3] = fit(x(ok_),y(ok_),(fittype('gauss3')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3 1 0.1 0.3 1 0.1 0.3],'Upper',[mH 50 8 mH 50 8 mH 50 8])));
    [curveFit4,goodness4,probs4] = fit(x(ok_),y(ok_),(fittype('gauss4')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3 1 0.1 0.3 1 0.1 0.3 1 0.1 0.3],'Upper',[mH 50 8 mH 50 8 mH 50 8 mH 50 8])));
    
    %Gaus1
    sse = 0;
    parfor i = 1:500
      [train,test] = crossvalind('LeaveMOut',N,1);
      [curveFit,goodness,probs] = fit(x(train),y(train),(fittype('gauss1')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[ 1 0.1 0.3],'Upper',[mH 50 8])));
      if probs.('iterations')>390;
        sse = sse + 5;
      else yhat = feval(curveFit,x(test));
        sse = sse + sum((yhat - y(test)).^2);
      end
    end
    CVerr_Gauss_1 =  sse / 500;

    %Gaus2    
    sse = 0;
    parfor i = 1:500
      [train,test] = crossvalind('LeaveMOut',N,1);
      [curveFit,goodness,probs] = fit(x(train),y(train),(fittype('gauss2')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3 1 0.1 0.3],'Upper',[mH 50 8 mH 50 8])));
      if probs.('iterations')>390;
        sse = sse + 5;
      else yhat = feval(curveFit,x(test));
        sse = sse + sum((yhat - y(test)).^2);
      end
    end
    CVerr_Gauss_2 =  sse / 500;
  
   
    %Gaus3 
    sse = 0;
    parfor i = 1:500
      [train,test] = crossvalind('LeaveMOut',N,1);
      [curveFit,goodness,probs] = fit(x(train),y(train),(fittype('gauss3')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3 1 0.1 0.3 1 0.1 0.3],'Upper',[mH 50 8 mH 50 8 mH 50 8])));
        if probs.('iterations')>390;
        sse = sse + 5;
        else yhat = feval(curveFit,x(test));
        sse = sse + sum((yhat - y(test)).^2);
        end
    end
   CVerr_Gauss_3 = sse / 500; 
  
   %Gaus4
   sse = 0;
    parfor i = 1:500
      [train,test] = crossvalind('LeaveMOut',N,1);
      [curveFit,goodness,probs] = fit(x(train),y(train),(fittype('gauss4')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3 1 0.1 0.3 1 0.1 0.3 1 0.1 0.3],'Upper',[mH 50 8 mH 50 8 mH 50 8 mH 50 8])));
      if probs.('iterations')>390;
        sse = sse + 5;
      else yhat = feval(curveFit,x(test));
        sse = sse + sum((yhat - y(test)).^2);
      end
    end
    CVerr_Gauss_4 = sse / 500; 
  
   
   
%% Five Gaussian
  elseif High >=15
    
    [curveFit1,goodness1,probs1] = fit(x(ok_),y(ok_),(fittype('gauss1')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3],'Upper',[mH 50 8]))); 
    [curveFit2,goodness2,probs2] = fit(x(ok_),y(ok_),(fittype('gauss2')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3 1 0.1 0.3],'Upper',[mH 50 8 mH 50 8])));
    [curveFit3,goodness3,probs3] = fit(x(ok_),y(ok_),(fittype('gauss3')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3 1 0.1 0.3 1 0.1 0.3],'Upper',[mH 50 8 mH 50 8 mH 50 8])));
    [curveFit4,goodness4,probs4] = fit(x(ok_),y(ok_),(fittype('gauss4')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3 1 0.1 0.3 1 0.1 0.3 1 0.1 0.3],'Upper',[mH 50 8 mH 50 8 mH 50 8 mH 50 8])));
    [curveFit5,goodness5,probs5] = fit(x(ok_),y(ok_),(fittype('gauss5')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3 1 0.1 0.3 1 0.1 0.3 1 0.1 0.3 1 0.1 0.3],'Upper',[mH 50 8 mH 50 8 mH 50 8 mH 50 8 mH 50 8])));
      
%Gaus1
    sse = 0;
    parfor i = 1:500
      [train,test] = crossvalind('LeaveMOut',N,1);
      [curveFit,goodness,probs] = fit(x(train),y(train),(fittype('gauss1')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[ 1 0.1 0.3],'Upper',[mH 50 8])));
      if probs.('iterations')>390;
        sse = sse + 5;
      else yhat = feval(curveFit,x(test));
        sse = sse + sum((yhat - y(test)).^2);
      end
    end
    CVerr_Gauss_1 =  sse / 500;

%Gaus2    
    sse = 0;
    parfor i = 1:500
      [train,test] = crossvalind('LeaveMOut',N,1);
      [curveFit,goodness,probs] = fit(x(train),y(train),(fittype('gauss2')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3 1 0.1 0.3],'Upper',[mH 50 8 mH 50 8])));
      if probs.('iterations')>390;
        sse = sse + 5;
      else yhat = feval(curveFit,x(test));
        sse = sse + sum((yhat - y(test)).^2);
      end
    end
    CVerr_Gauss_2 =  sse / 500;
  
   
%Gaus3 
    sse = 0;
    parfor i = 1:500
      [train,test] = crossvalind('LeaveMOut',N,1);
      [curveFit,goodness,probs] = fit(x(train),y(train),(fittype('gauss3')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3 1 0.1 0.3 1 0.1 0.3],'Upper',[mH 50 8 mH 50 8 mH 50 8])));
      if probs.('iterations')>390;
        sse = sse + 5;
      else yhat = feval(curveFit,x(test));
        sse = sse + sum((yhat - y(test)).^2);
      end
    end
   CVerr_Gauss_3 = sse / 500; 
  
%Gaus4
   sse = 0;
    parfor i = 1:500
      [train,test] = crossvalind('LeaveMOut',N,1);
      [curveFit,goodness,probs] = fit(x(train),y(train),(fittype('gauss4')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3 1 0.1 0.3 1 0.1 0.3 1 0.1 0.3],'Upper',[mH 50 8 mH 50 8 mH 50 8 mH 50 8])));
      if probs.('iterations')>390;
        sse = sse + 5;
      else yhat = feval(curveFit,x(test));
        sse = sse + sum((yhat - y(test)).^2);
      end
    end
    CVerr_Gauss_4 = sse / 500; 
   
%Gaus5
    sse = 0;
    parfor i = 1:500
      [train,test] = crossvalind('LeaveMOut',N,1);
      [curveFit,goodness,probs] = fit(x(train),y(train),(fittype('gauss5')),(fitoptions('method','NonlinearLeastSquares','Robust','off','Lower',[1 0.1 0.3 1 0.1 0.3 1 0.1 0.3 1 0.1 0.3 1 0.1 0.3],'Upper',[mH 50 8 mH 50 8 mH 50 8 mH 50 8 mH 50 8])));
      if probs.('iterations')>390;
        sse = sse + 5;
      else yhat = feval(curveFit,x(test));
        sse = sse + sum((yhat - y(test)).^2);
      end
    end
   CVerr_Gauss_5 = sse / 500; 

end
  
%% Test minimum value2
  Gaus1_test = min([CVerr_Gauss_1 CVerr_Gauss_2 CVerr_Gauss_3 CVerr_Gauss_4 CVerr_Gauss_5])
  
if Gaus1_test == CVerr_Gauss_1
    fileName = strcat('data/',mat2str(chromatograph),'.txt');
    dlmwrite(fileName,coeffvalues(curveFit1),' ');
    dlmwrite(fileName,goodness1.('rmse'),'-append');
    dlmwrite(fileName,goodness1.( 'rsquare'),'-append');
    dlmwrite(fileName,(Gaus1_test),'-append');
elseif Gaus1_test == CVerr_Gauss_2
    fileName = strcat('data/',mat2str(chromatograph),'.txt');
    dlmwrite(fileName,coeffvalues(curveFit2),' ');
    dlmwrite(fileName,goodness2.('rmse'),'-append');
    dlmwrite(fileName,goodness2.('rsquare'),'-append');
    dlmwrite(fileName,(Gaus1_test),'-append');
elseif Gaus1_test == CVerr_Gauss_3
    fileName = strcat('data/',mat2str(chromatograph),'.txt');
    dlmwrite(fileName,coeffvalues(curveFit3),' ');
    dlmwrite(fileName,goodness3.('rmse'),'-append');
    dlmwrite(fileName,goodness3.('rsquare'),'-append');
    dlmwrite(fileName,(Gaus1_test),'-append');
elseif Gaus1_test == CVerr_Gauss_4
    fileName = strcat('data/',mat2str(chromatograph),'.txt');
    dlmwrite(fileName,coeffvalues(curveFit4),' ');
    dlmwrite(fileName,goodness4.('rmse'),'-append');
    dlmwrite(fileName,goodness4.('rsquare'),'-append');
    dlmwrite(fileName,(Gaus1_test),'-append');
elseif Gaus1_test == CVerr_Gauss_5
    fileName = strcat('data/',mat2str(chromatograph),'.txt');
    dlmwrite(fileName,coeffvalues(curveFit5),' ');
    dlmwrite(fileName,goodness5.('rmse'),'-append');
    dlmwrite(fileName,goodness5.('rsquare'),'-append');
    dlmwrite(fileName,(Gaus1_test),'-append');
end

end


